package com.example.javacodegeeks.springevents.controllers;

import com.example.javacodegeeks.springevents.payloads.TicketPayload;
import com.example.javacodegeeks.springevents.processors.TicketEventProcessor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;

@RestController
@RequestMapping("/api/v1/ticket")
public class TicketController {

    @Autowired
    private TicketEventProcessor eventProcessor;

    @GetMapping("/generate")
    public String generateTicket() {
        TicketPayload payload = eventProcessor.process();
        return String.format("Ticket %s generated with pin %s!", payload.getId(),payload.getPin());
    }
}
