package com.example.javacodegeeks.springevents.events;

import com.example.javacodegeeks.springevents.payloads.TicketPayload;
import org.springframework.context.event.*;
import org.springframework.stereotype.Component;

import java.util.Date;

@Component
public class TicketEventListener {

    @EventListener
    public void handleContextStart(final ContextStartedEvent cse) {
        System.out.println("Start event: " + new Date(cse.getTimestamp()));
    }

    @EventListener
    public void onApplicationEvent(TicketEvent event) {
        logEvent(event.getPayload());
    }

    private void logEvent(TicketPayload payload) {
        System.out.println(String.format("Ticket %s generated with pin %s at %s", payload.getId(),
                payload.getPin(), new Date()));
    }
}
