package com.example.javacodegeeks.springevents.processors;

import com.example.javacodegeeks.springevents.events.TicketEvent;
import com.example.javacodegeeks.springevents.events.TicketEventPublisher;
import com.example.javacodegeeks.springevents.payloads.TicketPayload;
import org.apache.catalina.startup.ContextConfig;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ConfigurableApplicationContext;
import org.springframework.stereotype.Component;

import java.util.Random;
import java.util.UUID;

@Component
public class TicketEventProcessor {

    @Autowired
    private TicketEventPublisher publisher;

    @Autowired
    private ConfigurableApplicationContext ctx;

    public TicketPayload process() {
        TicketPayload payload = new TicketPayload();
        payload.setId(UUID.randomUUID().toString());
        payload.setPin(StringUtils.leftPad(String.valueOf(new Random().nextInt(9999)),4, "0"));
        TicketEvent event = new TicketEvent(this,payload);
        ctx.start();
        publisher.publish(event);
        return payload;
    }

}
